#include <stdio.h>

class TBase
{
public:
  virtual void print ();
  void pront ();
};

class TInteger: public TBase
{
private:
  int content;
public:
  virtual void print ();
  void pront ();
  void set (int i);
  TInteger (int i);
};

class TString: public TBase
{
private:
  const char *content;
public:
  virtual void print ();
  void pront ();
  void set (const char *s);
  TString (const char *s);
};

void TBase::pront ()
{
  printf ("Base\n");
}

void TBase::print ()
{
  printf ("Base\n");
}

void TInteger::print ()
{
  printf ("Integer: %d\n", content);
}

void TInteger::pront ()
{
  printf ("Integer\n");
}

void TInteger::set (int i)
{
  content = i;
}

TInteger::TInteger (int i)
{
  content = i;
}

void TString::print ()
{
  printf ("String: \"%s\"\n", content);
}

void TString::pront ()
{
  printf ("IString\n");
}

void TString::set (const char *s)
{
  content = s;
}

TString::TString (const char *s)
{
  content = s;
}

int main (void)
{
  TBase *object[] = { new TInteger (42),
                      new TString ("Hello, world!"),
                      NULL };

  dynamic_cast <TInteger *> (object[0])->set (137);
  dynamic_cast <TString *> (object[1])->set ("Hallo, Welt!");

  for (int i = 0; object[i]; i++)
    {
      object[i]->print ();
      object[i]->pront ();
    }

  for (int i = 0; object[i]; i++)
    delete object[i];

  return 0;
}
