#include <stdio.h>
#include <string.h>
#include <stdlib.h>

class TString
{
private:
  char *content;
public:
  void print ()
  {
    printf ("%s\n", content);
  }
  TString (const char *s = "Hello, world!")
  {
    printf ("Constructing TString object\n");
    content = (char *) malloc (strlen (s));
    strcpy (content, s);
  }
  virtual ~TString ()
  {
    printf ("Destructing TString object\n");
    free (content);
    content = NULL;
  }
};

int bye ()
{
  printf ("Bye!\n");
  return 0;
}

void do_something ()
{
  TString *s = new TString ("Hallo, Welt!");
  s->print ();
  delete s;
}

int main ()
{
  for (int i = 0; i < 1000; i++)
    do_something ();
  return bye ();
}
