#include <stdio.h>

class TBase
{
public:

  virtual void print ()
  {
    printf ("Base\n");
  }

  void pront ()
  {
    printf ("Base\n");
  }

};

class TInteger: public TBase
{
private:
  int content;
public:
  friend int main ();

  virtual void print ()
  {
    printf ("Integer: %d\n", content);
  }

  void pront ()
  {
    printf ("Integer\n");
  }

  void set (int i)
  {
    content = i;
  }

  TInteger (int i)
  {
    content = i;
  }

};

class TString: public TBase
{
private:
  const char *content;
public:
  friend int main ();

  virtual void print ()
  {
    printf ("String: \"%s\"\n", content);
  }

  void pront ()
  {
    printf ("String\n");
  }

  void set (const char *s)
  {
    content = s;
  }

  TString (const char *s)
  {
    content = s;
  }

};

int main (void)
{
  TBase *object[] = { new TInteger (42),
                      new TString ("Hello, world!"),
                      NULL };

  dynamic_cast <TInteger *> (object[0])->content = 137;
  dynamic_cast <TString *> (object[1])->content = "Hallo, Welt!";

  for (int i = 0; object[i]; i++)
    {
      object[i]->print ();
      object[i]->pront ();
    }

  for (int i = 0; object[i]; i++)
    delete object[i];

  return 0;
}
