#include <iostream>
#include <string>

using namespace std;

template <typename argtype>
class list
{
  struct node
  {
    argtype content;
    node *next;
  };
  node *root;
public:
  list ();
  void insert (argtype x);
  void output ();
};

template <typename argtype>
list <argtype>::list ()
{
  root = NULL;
}

template <typename argtype>
void list <argtype>::insert (argtype x)
{
  node *n = new node;
  n->content = x;
  n->next = root;
  root = n;
}

template <typename argtype>
void list <argtype>::output ()
{
  for (node *p = root; p; p = p->next)
    cout << p->content << endl;
}

int main ()
{
  list <string> s;
  s.insert ("one");
  s.insert ("two");
  s.insert ("three");
  s.output ();
  list <int> i;
  i.insert (1);
  i.insert (2);
  i.insert (3);
  i.output ();
  return 0;
}
