#include <iostream>
#include <string>
#include <memory>

using std::cout;
using std::endl;
using std::string;
using std::shared_ptr;
using std::weak_ptr;

struct container
{
  string content;
  container (const char *s)
  {
    content = s;
  }
  ~container ()
  {
    cout << "Bye: " << content << endl;
  }
  weak_ptr <container> next;
};

int main ()
{
  shared_ptr <container> hello1 (new container ("Hello,"));
  shared_ptr <container> hello2 (new container ("world!"));
  hello1->next = hello2;
  hello2->next = hello1;
  cout << hello1->content << " " << hello2->content << endl;
  return 0;
}
