#include <iostream>
#include <string>
#include <memory>

using std::cout;
using std::endl;
using std::string;
using std::unique_ptr;

int main ()
{
  unique_ptr <string> hello (new string ("Hello, world!"));
  unique_ptr <string> storage;

  storage = hello;

  // Jetzt kommt ein anderer Thread und macht:

  if (hello)
    delete hello;

  // Jetzt sind wir wieder im ursprünglichen Thread.

  hello = NULL;

  cout << *storage << endl;

  if (storage)
    delete storage;

  return 0;
}
