#include <iostream>
#include <string>
#include <memory>

using std::cout;
using std::endl;
using std::string;
using std::unique_ptr;

int main ()
{
  unique_ptr <string> hello (new string ("Hello, world!"));
  unique_ptr <string> storage;

  storage = move (hello);  // setzt gleichzeitig auf NULL

  // Ein anderer Thread hat keine Chance mehr, sich zwischen die Zeiger-Zuweisung
  // und das Auf-NULL-Setzen zu schieben.

  cout << *storage << endl;

  // if (storage)
  //   delete storage;   --> geschieht automatisch

  return 0;
}
