#include <iostream>
#include <string>

using namespace std;

class TComplicated
{
  string *content;

public:
  TComplicated ()
  {
    content = NULL;
  }

  TComplicated (const char *content)
  {
    this->content = new string (content);
  }

  TComplicated (const TComplicated &src)
  {
    if (src.content)
      this->content = new string (*src.content);
    else
      this->content = NULL;
  }

  ~TComplicated ()
  {
    cout << "~TComplicated (): content = ";
    print ();
    if (content)
      delete content;
    content = NULL;
  }

  void print ()
  {
    if (content)
      cout << *content << endl;
    else
      cout << "(NULL)" << endl;
  }
};

void foo (TComplicated &x)
{
  x.print ();
}

int main ()
{
  TComplicated c = "Hello, world!";
  foo (c);
  return 0;
}
