#include <stdio.h>

struct TBase
{
  virtual void print ()
  {
    printf ("(Base)\n");
  }
};

struct THello: public TBase
{
  const char *content;

  THello (const char *s)
  {
    content = s;
  }

  virtual void print ()
  {
    printf ("%s\n", content);
  }
};

int main ()
{
  THello h = "Hello, world!";
  h.print ();
  return 0;
}
