#include <stdio.h>
#include <stdint.h>

int bin_exp (int b, int e)
{
  int res = 1;
  int pot = b;
  uint8_t mask = 1;
  while (mask <= e)
    {
      if (e & mask)
        res *= pot;
      pot *= pot;
      mask <<= 1;
    }
  return res;
}

int main (void)
{
  int b = 2;
  int e = 18;
  printf ("%d hoch %d = %d\n", b, e, bin_exp (b, e));
  return 0;
}
