include <stdio.h>
#include <stdint.h>

typedef uint64_t uint128_t[2];

extern void sum (uint128_t a, uint128_t b, uint128_t result);

void print128 (uint128_t a)
{
  printf ("0x%08lx 0x%08lx 0x%08lx 0x%08lx", a[0] >> 32, a[0] & 0xffffffff, a[1] >> 32, a[1] & 0xffffffff);
}

int main (void)
{
  uint128_t a = { 0x0000000080000007, 0x1234567887654321 };
  uint128_t b = { 0x0000000080000014, 0xf876543287654321 };
  /* ----------------------1-------1-----------1-------- */
  /*              0x000000010000001c, 0x0aaaaaab0eca8642 */
  uint128_t c;
  sum (a, b, c);
  printf ("  ");
  print128 (a);
  printf ("\n+ ");
  print128 (b);
  printf ("\n= ");  /* Jetzt ist die Ausgabe korrekt, weil die Funktion korrekt rechnet. */
  print128 (c);
  printf ("\n");
  return 0;
}
