#include <stdio.h>

typedef struct node
{
  int content;
  struct node *prev, *next;
} node;

node *reverse_list (node *root)  /* erst mal nur für 1. Element tauschen */
{
  node *tmp = root->next;
  root->next = root->prev;
  root->prev = tmp;
  return root;
}

int main (void)
{
  node node1 = { 1, NULL, NULL };
  node node2 = { 2, &node1, NULL };
  node1.next = &node2;
  node node3 = { 3, &node2, NULL };
  node2.next = &node3;
  node node4 = { 4, &node3, NULL };
  node3.next = &node4;

  for (node *p = &node1; p; p = p->next)
    {
      printf ("%d: %016zx\n", p->content, (size_t) p);
    }

  for (node *p = &node1; p; p = p->next)
    {
      p = reverse_list (p);
      printf ("%d: %016zx next: %016zx prev: %016zx\n", p->content, (size_t) p, (size_t) p->next, (size_t) p->prev);
    }

  for (node *p = &node1; p; p = p->prev)
    {
      printf ("%d\n", p->content);
    }

  return 0;
}
