#include <iostream>
#include <sstream>
#include <string.h>

using namespace std;

class philosophy_exception: public exception
{
  int answer;
  static char buffer[42];
public:
  philosophy_exception (int a) { answer = a; }
  virtual const char *what () const noexcept;
};

const char *philosophy_exception::what () const noexcept
{
  ostringstream tmp_buffer;
  tmp_buffer << "philosophy exception #" << answer;
  strcpy (buffer, tmp_buffer.str ().c_str ());
  return buffer;
}

char philosophy_exception::buffer[42] = "Marvin";

int main ()
{
  int answer;
  cout << "What's your answer? ";
  cin >> answer;
  try
  {
    if (answer == 42)
      cout << "And what was the question?" << endl;
    else
      throw philosophy_exception (answer);
  }
  catch (exception &e)
  {
    cout << "caught exception: " << e.what () << endl;
  }
  return 0;
}
