#include <iostream>

using namespace std;

class philosophy_exception: public exception
{
  int answer;
public:
  philosophy_exception (int a) { answer = a; }
  int get_answer () { return answer; }
};

int main ()
{
  int answer;
  cout << "What's your answer? ";
  cin >> answer;
  try
  {
    if (answer != 42)
      throw philosophy_exception (answer);
    cout << "And what was the question?" << endl;
  }
  catch (exception &e)
  {
    cout << "caught exception" << endl;
  }
  catch (philosophy_exception &e)
  {
    cout << "caught philosophy exception: " << e.get_answer () << endl;
  }
  return 0;
}
