#include <iostream>
#include <sstream>

using namespace std;

class philosophy_exception: public exception
{
  int answer;
public:
  philosophy_exception (int a) { answer = a; }
  virtual const char *what () const noexcept;
};

const char *philosophy_exception::what () const noexcept
{
  ostringstream buffer;
  buffer << "philosophy exception #" << answer;
  return buffer.str ().c_str ();
}

int main ()
{
  int answer;
  cout << "What's your answer? ";
  cin >> answer;
  try
  {
    if (answer == 42)
      cout << "And what was the question?" << endl;
    else
      throw philosophy_exception (answer);
  }
  catch (exception &e)
  {
    cout << "caught exception: " << e.what () << endl;
  }
  return 0;
}
