#include <iostream>
#include <string>

using namespace std;

class TComplicated
{
  string *content;

public:
  TComplicated ()
  {
    content = NULL;
  }

  TComplicated (const char *content)
  {
    this->content = new string (content);
  }

  ~TComplicated ()
  {
    cout << "~TComplicated (): content = ";
    print ();
    if (content)
      delete content;
    content = NULL;
  }

  void print ()
  {
    if (content)
      cout << *content << endl;
    else
      cout << "(NULL)" << endl;
  }
};

int main ()
{
  TComplicated c = "Hello, world!";
  c.print ();
  TComplicated d;
  d.print ();
  return 0;
}
