#include <stdio.h>

struct TBase
{
  virtual void print ()
  {
    printf ("(Base)\n");
  }
};

struct THello: public TBase
{
  const char *content;

  THello (const char *s)
  {
    content = s;
  }

  explicit THello (const TBase &b)
  {
    content = "(Base)";
  }

  virtual void print ()
  {
    printf ("%s\n", content);
  }
};

int main ()
{
  TBase b;
  THello h = b;
  h.print ();
  return 0;
}
