#include <stdio.h>

void ext_eucl (int a, int b, int *ss, int *tt, int *ggt)
{
  int r0 = a;
  int r1 = b;
  int s0 = 1;
  int s1 = 0;
  int t0 = 0;
  int t1 = 1;
  loop: ;
    int q = r0 / r1;
    int r2 = r0 % r1;
    int s2 = s0 - q * s1;
    int t2 = t0 - q * t1;
    if (r2 == 0)
      {
        *ggt = r2;
        *ss = s2;
        *tt = t2;
        return;
      }
    r0 = r1;
    s0 = s1;
    r1 = r2;
    s1 = s2;
  goto loop;
}

int main (void)
{
  int p = 11117;
  int q = 11171;
  int n = (p - 1) * (q - 1);
  int e = 137;
  int d;
  int t;
  int ggt;
  ext_eucl (e, n, &d, &t, &ggt);
  while (d < 0)
    d += n;
  printf ("d = %d\n", d);
  return 0;
}
