#include <stdio.h>
#include <stdint.h>

typedef uint32_t uint128_t[4];

void sum (uint128_t a, uint128_t b, uint128_t result)
{
  result[3] = a[3] + b[3];  /* Fehler: Übertrag ("carry") nicht berücksichtigt! */
  result[2] = a[2] + b[2];
  result[1] = a[1] + b[1];
  result[0] = a[0] + b[0];
}

void print128 (uint128_t a)
{
  printf ("0x%08x 0x%08x 0x%08x 0x%08x", a[0], a[1], a[2], a[3]);
}

int main (void)
{
  uint128_t a = { 0, 0x80000007, 0x12345678, 0x87654321 };
  uint128_t b = { 0, 0x80000014, 0x98765432, 0x87654321 };
  /* -------------1-----------------------1------------ */
  /*              1, 0x0000001b, 0xaaaaaaab, 0x0eca8642 */
  uint128_t c;
  sum (a, b, c);
  printf ("  ");
  print128 (a);
  printf ("\n+ ");
  print128 (b);
  printf ("\n= ");
  print128 (c);
  printf ("\n");
  return 0;
}
