#include <stdio.h>
#include <stdint.h>

typedef uint64_t uint128_t[2];

void sum (uint128_t a, uint128_t b, uint128_t result)
{
  result[1] = a[1] + b[1];  /* Fehler: Übertrag fehlt! */
  result[0] = a[0] + b[0];
}

void print128 (uint128_t a)
{
  printf ("0x%08lx 0x%08lx 0x%08lx 0x%08lx", a[0] >> 32, a[0] & 0xffffffff, a[1] >> 32, a[1] & 0xffffffff);
}

int main (void)
{
  uint128_t a = { 0x0000000080000007, 0x1234567887654321 };
  uint128_t b = { 0x0000000080000014, 0x9876543287654321 };
  /* ----------------------1-------------------1-------- */
  /*              0x000000010000001b, 0xaaaaaaab0eca8642 */
  uint128_t c;
  sum (a, b, c);
  printf ("  ");
  print128 (a);
  printf ("\n+ ");
  print128 (b);
  printf ("\n= ");  /* Vorsicht, Falle: Die Ausgabe ist korrekt, weil in unserem Beispiel    */
  print128 (c);     /* der Übertrag nur jeweils innerhalb einer 64-Bit-"Ziffer" stattfindet, */
  printf ("\n");    /* aber nicht von der rechten "Ziffer" zur linken.                       */
  return 0;
}
