#include <stdio.h>
#include <stdint.h>
#include <inttypes.h>
#include <string.h>

uint64_t decode (char *s)
{
  uint64_t a = 0;
  for (int i = strlen (s) - 1; i >= 0; i--)
    {
      a <<= 4;
      char c = s[i];
      if (c >= '0' && c <= '9')
        a |= c - '0';
      else if (c >= 'A' && c <= 'F')
        a |= c - 'A' + 10;
      else if (c >= 'a' && c <= 'f')
        a |= c - 'a' + 10;
    }
  return a;
}

int main (void)
{
  uint64_t a = decode ("affe123deadbeef");
  printf ("%016" PRIx64 "\n", a);
  return 0;
}
