#include <stdio.h>
#include <stdint.h>
#include <inttypes.h>
#include <string.h>

uint64_t decode (char *s)
{
  uint64_t a = 0;
  int lm1 = strlen (s) - 1;
  for (int i = lm1; i >= 0; i--)
    {
      char c = s[i];
      uint64_t b = 0;
      if (c >= '0' && c <= '9')
        b = c - '0';
      else if (c >= 'A' && c <= 'F')
        b = c - 'A' + 10;
      else if (c >= 'a' && c <= 'f')
        b = c - 'a' + 10;
      a |= b << 4 * (lm1 - i);
    }
  return a;
}

int main (void)
{
  uint64_t a = decode ("affe123deadbeef");
  printf ("%016" PRIx64 "\n", a);
  return 0;
}
